
#pragma once

// DiffEngine ////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////
// S.Rodriguez - Feb 2003
//////////////////////////////////////////////////////////////////////
//
//




// BuffBlock class declaration //////////////////////////////////////////////////:


class BuffBlock
{
    struct BuffBlockUnit
    {
        void* m_pBuffer;
        long  m_nLength;
        long  m_nAllocatedLength;

        BuffBlockUnit() {}
        BuffBlockUnit(void*) {}
    };

    CTemplateArray<BuffBlockUnit> m_arrayBlockPtrs;
    long    m_nLengthNewBlock;
    void*   m_pInsertionBuffer;

public:
    BuffBlock();
    ~BuffBlock();

    void free();

    void setDefaultAllocationLength(long nLength); // in bytes

    void* getFirstBuffer(); // pointer to first block
    long getFirstLength();
    long getFirstAllocatedLength();

    void* getLastBuffer(); // pointer to last block
    long getLastLength();
    long getLastAllocatedLength();

    long getTotalLength();

    long getBlockCount();
    void* getBlock(long i, long& o_nLength, long& o_nAllocatedLength);

	bool addChar(char c);
    bool addEOLIfRequired();
    bool addByte(unsigned char c);
	bool addWord(WORD w);
    bool addBuffer(/*in*/CString& s);
    bool addBuffer(/*in*/LPSTR s);
    bool addBuffer(/*in*/void* p, long length);
    bool addBuffer(/*in*/BuffBlock* in);
    void* addBufferReturnPointer(/*in*/void* p, long length);

};





// CDiffEngine class declaration ///////////////////////////////////////////////

class CDiffEngine
{
	// Members
protected:
	CString m_szColorText, m_szColorBackground, m_szColorChanged, m_szColorAdded, m_szColorDeleted; // used by the html renderer
	CString m_szHeader, m_szFooter;

	// Constructor
public:
	CDiffEngine();

	// Accessors
public:

	// Methods

	// compare f1 (old version) with f2 (new version)
	// and build two new copies of those file objects with status on a line by line basis
	//
	BOOL Diff(	/*in*/CFilePartition &f1, /*in*/CFilePartition &f2,
				/*out*/CFilePartition &f1_bis, /*out*/CFilePartition &f2_bis);

	// build html report
	//
	void SetTitles(/*in*/CString &szHeader, /*in*/CString &szFooter);
	void SetColorStyles(/*in*/CString &szText, /*in*/CString &szBackground, /*in*/CString &szChanged, /*in*/CString &szAdded, /*in*/CString &szDeleted);

	void Serialize(/*in*/CFilePartition &f1, /*in*/CFilePartition &f2, /*out*/BuffBlock& o);

	BOOL ExportAsHtml(/*in*/CString &szFilename, /*in*/BuffBlock& o);
	BOOL ExportAsStdout(/*in*/BuffBlock& o);

	// Helpers
protected:
	void Escape(AString &s, /*out*/BuffBlock& o);
};

